/***********************************************************************
*                                                                      *
* (C) 2007, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#include "newinput.h"

#include "mainguiwindow.h"
#include "../corefactory.h"
#include "../core_I.h"
#include "../fsm_I.h"

NewInput::NewInput(QWidget* qw) {
  w = qw;
  setupUi(this);
}

string NewInput::QStrToStr(QString q) {
  string s (q.toAscii());
  return s;
}

void NewInput::accept() {
  QString qs = lineEditInput->text();
  string name = QStrToStr(qs);
  Core_I& c = CoreFactory::getCore_I();  
  Fsm_I& f = c.getCurrentFsm();
 while(!name.empty()) { 
    string::size_type len = name.length(); 
    string::size_type sty = name.find_first_not_of(' ',0);
    string::size_type sty2 = name.find_first_of(' ',sty);
    if((sty != string::npos) && (sty2 != string::npos) ) {
      string next;
      next.assign(name,sty,(sty2 - sty)); 
      int i = f.getNumberOfInputs();
      i++;
      f.numberOfIns(i);
      f.inputName(i - 1, next);
      qs = QString::fromStdString(next);
      QTreeWidgetItem* twi = new QTreeWidgetItem((dynamic_cast<MainguiWindow*>(w))->listofinputs);
      twi->setText(0,qs);
      name.assign(name,sty2, len - 1);
    } else {
      if(sty != string::npos ) {
	name.assign(name,sty, (len - sty));
	int i = f.getNumberOfInputs();
	i++;
	f.numberOfIns(i);
	f.inputName(i - 1, name);
	qs = QString::fromStdString(name);
	QTreeWidgetItem* twi = new QTreeWidgetItem((dynamic_cast<MainguiWindow*>(w))->listofinputs);
	twi->setText(0,qs);
      }
	name = "";
    }
  }
  this->done(0);
}
