/***********************************************************************
*                                                                      *
* (C) 2007, Frank Lemke, Computer Architecture Group,                  *
* University of Mannheim, Germany                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, write to the Free Software          *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
* USA                                                                  *
*                                                                      *
* For informations regarding this file contact                         *
*			      office@mufasa.informatik.uni-mannheim.de *
*                                                                      *
***********************************************************************/

#include "renameinput.h"

#include "mainguiwindow.h"
#include "../corefactory.h"
#include "../core_I.h"
#include "../fsm_I.h"


RenameInput::RenameInput(QWidget* qw) : QDialog(qw) {
  w = qw;
  setupUi(this); 
  QTreeWidgetItem* it = (dynamic_cast<MainguiWindow*>(w))->listofinputs->currentItem(); 
  index = (dynamic_cast<MainguiWindow*>(w))->listofinputs->indexOfTopLevelItem(it);
  lineEditInput->setText(it->text(0));
}
 
string RenameInput::QStrToStr(QString q) {
  string s (q.toAscii());
  return s;
}


void RenameInput::accept() {  
  QString qs = lineEditInput->text();
  string name = QStrToStr(qs);
  Core_I& c = CoreFactory::getCore_I();  
  Fsm_I& f = c.getCurrentFsm();
  f.inputName(index, name);
  (dynamic_cast<MainguiWindow*>(w))->listofinputs->currentItem()->setText(0,qs);
  this->done(0);
}
